Index: contrib/crossrpms/rtems/Makefile.am
===================================================================
--- contrib/crossrpms/rtems/Makefile.am	(revision 965c3924ff749986bf0141999b9c4567f1bf0e5a)
+++ contrib/crossrpms/rtems/Makefile.am	(revision 549e88f62312dd972d0b1c9353999611404934bd)
@@ -13,17 +13,17 @@
 EXTRA_DIST += binutils-sources.add
 
-BINUTILS_SUBPACKAGES = $(top_builddir)/common/common.add
-BINUTILS_SUBPACKAGES += ../binutils/binutils.add
-BINUTILS_SUBPACKAGES += ../binutils/prep.add
-BINUTILS_SUBPACKAGES += ../binutils/build.add
-BINUTILS_SUBPACKAGES += ../binutils/install.add
-BINUTILS_SUBPACKAGES += ../binutils/rpm-install.add
-BINUTILS_SUBPACKAGES += $(top_builddir)/common/clean.add
-BINUTILS_SUBPACKAGES += ../binutils/target-binutils.add
-BINUTILS_SUBPACKAGES += ../binutils/base-binutils.add
+BINUTILS_SUBPACKAGES = $(top_srcdir)/common/common.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/binutils.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/prep.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/build.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/install.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/rpm-install.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/common/clean.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/target-binutils.add
+BINUTILS_SUBPACKAGES += $(top_srcdir)/binutils/base-binutils.add
 
 $(TARGET)-binutils.spec.in: $(BINUTILS_SUBPACKAGES) Makefile.am binutils-sources.add
 	cat $(BINUTILS_SUBPACKAGES) | sed \
-	  -e "/[@]SOURCES[@]/r ./binutils-sources.add" \
+	  -e "/[@]SOURCES[@]/r $(srcdir)/binutils-sources.add" \
 	  -e "/[@]SOURCES[@]/d" \
 	  -e "s/[@]BINUTILS_VERS[@]/$(BINUTILS_VERS)/g" \
@@ -34,5 +34,5 @@
 
 @rpmprefix@$(TARGET)-binutils.spec: $(TARGET)-binutils.spec.in
-	$(MKSPEC) $(srcdir)/$(TARGET)-binutils.spec.in > $@
+	$(MKSPEC) $(TARGET)-binutils.spec.in > $@
 CLEANFILES += @rpmprefix@$(TARGET)-binutils.spec
 noinst_DATA += @rpmprefix@$(TARGET)-binutils.spec
@@ -45,23 +45,23 @@
 EXTRA_DIST += gcc-sources.add
 
-GCC_SUBPACKAGES = $(top_builddir)/common/common.add
-GCC_SUBPACKAGES += ../gcc/gccnewlib.add
-GCC_SUBPACKAGES += ../gcc/prep.add
-GCC_SUBPACKAGES += ../gcc/build.add
-GCC_SUBPACKAGES += ../gcc/install.add
-GCC_SUBPACKAGES += ../gcc/rpm-install.add
-GCC_SUBPACKAGES += $(top_builddir)/common/clean.add
-GCC_SUBPACKAGES += ../gcc/target-gcc.add
-GCC_SUBPACKAGES += ../gcc/base-gcc.add
-GCC_SUBPACKAGES += ../gcc/target-c++.add
-GCC_SUBPACKAGES += ../gcc/target-gfortran.add
-GCC_SUBPACKAGES += ../gcc/base-gfortran.add
-GCC_SUBPACKAGES += ../gcc/target-objc.add
-GCC_SUBPACKAGES += ../gcc/target-newlib.add
-GCC_SUBPACKAGES += ../gcc/base-newlib.add
+GCC_SUBPACKAGES = $(top_srcdir)/common/common.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/gccnewlib.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/prep.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/build.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/install.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/rpm-install.add
+GCC_SUBPACKAGES += $(top_srcdir)/common/clean.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/target-gcc.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/base-gcc.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/target-c++.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/target-gfortran.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/base-gfortran.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/target-objc.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/target-newlib.add
+GCC_SUBPACKAGES += $(top_srcdir)/gcc/base-newlib.add
 
 $(TARGET)-gcc.spec.in: $(GCC_SUBPACKAGES) Makefile.am gcc-sources.add gcc-prep.add
 	cat $(GCC_SUBPACKAGES) | sed \
-	  -e "/[@]SOURCES[@]/r ./gcc-sources.add" \
+	  -e "/[@]SOURCES[@]/r $(srcdir)/gcc-sources.add" \
 	  -e "/[@]SOURCES[@]/d" \
 	  -e "/[@]PREP[@]/r ./gcc-prep.add" \
@@ -78,5 +78,5 @@
 
 @rpmprefix@$(TARGET)-gcc.spec: $(TARGET)-gcc.spec.in
-	$(MKSPEC) $(srcdir)/$(TARGET)-gcc.spec.in > $@
+	$(MKSPEC) $(TARGET)-gcc.spec.in > $@
 CLEANFILES += @rpmprefix@$(TARGET)-gcc.spec
 noinst_DATA += @rpmprefix@$(TARGET)-gcc.spec
@@ -87,17 +87,17 @@
 EXTRA_DIST += gdb-sources.add
 
-GDB_SUBPACKAGES = $(top_builddir)/common/common.add
-GDB_SUBPACKAGES += ../gdb/gdb.add
-GDB_SUBPACKAGES += ../gdb/prep.add
-GDB_SUBPACKAGES += ../gdb/build.add
-GDB_SUBPACKAGES += ../gdb/install.add
-GDB_SUBPACKAGES += ../gdb/rpm-install.add
-GDB_SUBPACKAGES += $(top_builddir)/common/clean.add
-GDB_SUBPACKAGES += ../gdb/target-gdb.add
-GDB_SUBPACKAGES += ../gdb/base-gdb.add
+GDB_SUBPACKAGES = $(top_srcdir)/common/common.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/gdb.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/prep.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/build.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/install.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/rpm-install.add
+GDB_SUBPACKAGES += $(top_srcdir)/common/clean.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/target-gdb.add
+GDB_SUBPACKAGES += $(top_srcdir)/gdb/base-gdb.add
 
 $(TARGET)-gdb.spec.in: $(GDB_SUBPACKAGES) Makefile.am gdb-sources.add
 	cat $(GDB_SUBPACKAGES) | sed \
-	  -e "/[@]SOURCES[@]/r ./gdb-sources.add" \
+	  -e "/[@]SOURCES[@]/r $(srcdir)/gdb-sources.add" \
 	  -e "/[@]SOURCES[@]/d" \
 	  -e "s/[@]GDB_VERS[@]/$(GDB_VERS)/g" \
@@ -108,5 +108,5 @@
 
 @rpmprefix@$(TARGET)-gdb.spec: $(TARGET)-gdb.spec.in
-	$(MKSPEC) $(srcdir)/$(TARGET)-gdb.spec.in > $@
+	$(MKSPEC) $(TARGET)-gdb.spec.in > $@
 CLEANFILES += @rpmprefix@$(TARGET)-gdb.spec
 noinst_DATA += @rpmprefix@$(TARGET)-gdb.spec