Index: cpukit/libnetworking/kern/uipc_mbuf.c
===================================================================
--- cpukit/libnetworking/kern/uipc_mbuf.c	(revision 00a578ad6bbc15e42afde811d4d6f4051a63303c)
+++ cpukit/libnetworking/kern/uipc_mbuf.c	(revision 558e177e5353c44d6bccbc257645d24fa5573c08)
@@ -11,8 +11,4 @@
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
  * 4. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
@@ -166,8 +162,7 @@
 
 struct mbuf *
-m_free(m)
-	struct mbuf *m;
-{
-	register struct mbuf *n;
+m_free(struct mbuf *m)
+{
+	struct mbuf *n;
 
 	MFREE(m, n);
@@ -176,15 +171,14 @@
 
 void
-m_freem(m)
-	register struct mbuf *m;
-{
-	register struct mbuf *n;
-
-	if (m == NULL)
+m_freem(struct mbuf *mb)
+{
+	struct mbuf *n;
+
+	if (mb == NULL)
 		return;
 	do {
-		MFREE(m, n);
-		m = n;
-	} while (m);
+		MFREE(mb, n);
+		mb = n;
+	} while (mb);
 }
 
@@ -199,7 +193,5 @@
  */
 struct mbuf *
-m_prepend(m, len, how)
-	register struct mbuf *m;
-	int len, how;
+m_prepend(struct mbuf *m, int len, int how)
 {
 	struct mbuf *mn;
@@ -230,11 +222,8 @@
 
 struct mbuf *
-m_copym(m, off0, len, wait)
-	register struct mbuf *m;
-	int off0, wait;
-	register int len;
-{
-	register struct mbuf *n, **np;
-	register int off = off0;
+m_copym(struct mbuf *m, int off0, int len, int wait)
+{
+	struct mbuf *n, **np;
+	int off = off0;
 	struct mbuf *top;
 	int copyhdr = 0;
@@ -245,5 +234,5 @@
 		copyhdr = 1;
 	while (off > 0) {
-		if (m == 0)
+		if (m == NULL)
 			panic("m_copym");
 		if (off < m->m_len)
@@ -255,5 +244,5 @@
 	top = 0;
 	while (len > 0) {
-		if (m == 0) {
+		if (m == NULL) {
 			if (len != M_COPYALL)
 				panic("m_copym");
@@ -262,5 +251,5 @@
 		MGET(n, wait, m->m_type);
 		*np = n;
-		if (n == 0)
+		if (n == NULL)
 			goto nospace;
 		if (copyhdr) {
@@ -291,5 +280,5 @@
 		np = &n->m_next;
 	}
-	if (top == 0)
+	if (top == NULL)
 		MCFail++;
 	return (top);
@@ -297,5 +286,5 @@
 	m_freem(top);
 	MCFail++;
-	return (0);
+	return (NULL);
 }
 
@@ -305,7 +294,5 @@
  */
 struct mbuf *
-m_copypacket(m, how)
-	struct mbuf *m;
-	int how;
+m_copypacket(struct mbuf *m, int how)
 {
 	struct mbuf *top, *n, *o;
@@ -361,12 +348,7 @@
  */
 int
-m_copydata(m, off, len, cp)
-	register struct mbuf *m;
-	register int off;
-	register int len;
-	caddr_t cp;
-{
-	register unsigned count;
-/*	struct mbuf *m0 = m; */
+m_copydata(const struct mbuf *m, int off, int len, caddr_t cp)
+{
+	u_int count;
 
 	if (off < 0 || len < 0)
@@ -414,6 +396,5 @@
  */
 void
-m_cat(m, n)
-	register struct mbuf *m, *n;
+m_cat(struct mbuf *m, struct mbuf *n)
 {
 	while (m->m_next)
@@ -435,11 +416,9 @@
 
 void
-m_adj(mp, req_len)
-	struct mbuf *mp;
-	int req_len;
-{
-	register int len = req_len;
-	register struct mbuf *m;
-	register int count;
+m_adj(struct mbuf *mp, int req_len)
+{
+	int len = req_len;
+	struct mbuf *m;
+	int count;
 
 	if ((m = mp) == NULL)
@@ -519,10 +498,8 @@
 
 struct mbuf *
-m_pullup(n, len)
-	register struct mbuf *n;
-	int len;
-{
-	register struct mbuf *m;
-	register int count;
+m_pullup(struct mbuf *n, int len)
+{
+	struct mbuf *m;
+	int count;
 	int space;
 
@@ -543,5 +520,5 @@
 			goto bad;
 		MGET(m, M_DONTWAIT, n->m_type);
-		if (m == 0)
+		if (m == NULL)
 			goto bad;
 		m->m_len = 0;
@@ -571,8 +548,8 @@
 	m->m_next = n;
 	return (m);
-bad:
+ bad:
 	m_freem(n);
 	MPFail++;
-	return (0);
+	return (NULL);
 }
 
@@ -583,20 +560,18 @@
  */
 struct mbuf *
-m_split(m0, len0, wait)
-	register struct mbuf *m0;
-	int len0, wait;
-{
-	register struct mbuf *m, *n;
-	unsigned len = len0, remain;
+m_split(struct mbuf *m0, int len0, int wait)
+{
+	struct mbuf *m, *n;
+	u_int len = len0, remain;
 
 	for (m = m0; m && len > m->m_len; m = m->m_next)
 		len -= m->m_len;
-	if (m == 0)
-		return (0);
+	if (m == NULL)
+		return (NULL);
 	remain = m->m_len - len;
 	if (m0->m_flags & M_PKTHDR) {
 		MGETHDR(n, wait, m0->m_type);
-		if (n == 0)
-			return (0);
+		if (n == NULL)
+			return (NULL);
 		n->m_pkthdr.rcvif = m0->m_pkthdr.rcvif;
 		n->m_pkthdr.len = m0->m_pkthdr.len - len0;
@@ -617,5 +592,5 @@
 	} else if (remain == 0) {
 		n = m->m_next;
-		m->m_next = 0;
+		m->m_next = NULL;
 		return (n);
 	} else {
@@ -642,5 +617,5 @@
 	m->m_len = len;
 	n->m_next = m->m_next;
-	m->m_next = 0;
+	m->m_next = NULL;
 	return (n);
 }
@@ -649,14 +624,12 @@
  */
 struct mbuf *
-m_devget(buf, totlen, off0, ifp, copy)
-	char *buf;
-	int totlen, off0;
-	struct ifnet *ifp;
-	void (*copy) __P((char *from, caddr_t to, u_int len));
-{
-	register struct mbuf *m;
-	struct mbuf *top = 0, **mp = &top;
-	register int off = off0, len;
-	register char *cp;
+m_devget(char *buf, int totlen, int off0, struct ifnet *ifp, 
+	void (*copy)(char *from, caddr_t to, u_int len))
+{
+	struct mbuf *m;
+	struct mbuf *top = NULL, **mp = &top;
+	int len;
+	int off = off0;
+	char *cp;
 	char *epkt;
 
@@ -702,7 +675,7 @@
 		}
 		if (copy)
-			copy(cp, mtod(m, caddr_t), (unsigned)len);
+			copy(cp, mtod(m, caddr_t), (u_int)len);
 		else
-			bcopy(cp, mtod(m, caddr_t), (unsigned)len);
+			bcopy(cp, mtod(m, caddr_t), (u_int)len);
 		cp += len;
 		*mp = m;
@@ -727,16 +700,16 @@
 	caddr_t cp;
 {
-	register int mlen;
-	register struct mbuf *m = m0, *n;
+	int mlen;
+	struct mbuf *m = m0, *n;
 	int totlen = 0;
 
-	if (m0 == 0)
+	if (m0 == NULL)
 		return 0;
 	while (off > (mlen = m->m_len)) {
 		off -= mlen;
 		totlen += mlen;
-		if (m->m_next == 0) {
+		if (m->m_next == NULL) {
 			n = m_getclr(M_DONTWAIT, m->m_type);
-			if (n == 0) {
+			if (n == NULL) {
 				/*panic("m_copyback() : malformed chain\n");*/
 				return -1;
@@ -749,5 +722,5 @@
 	while (len > 0) {
 		mlen = min (m->m_len - off, len);
-		bcopy(cp, off + mtod(m, caddr_t), (unsigned)mlen);
+		bcopy(cp, off + mtod(m, caddr_t), (u_int)mlen);
 		cp += mlen;
 		len -= mlen;
@@ -759,5 +732,5 @@
 			break;
 		}
-		if (m->m_next == 0) {
+		if (m->m_next == NULL) {
 			n = m_get(M_DONTWAIT, m->m_type);
 			if (n == 0) {