Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 4d32a76de07c6a5ae3e9a2b2180709bfe3c9567e)
+++ cpukit/ChangeLog	(revision 569b3f41413f9b7b1b43cce256f4b8594dbeabdf)
@@ -1,2 +1,10 @@
+2010-06-24	Gedare Bloom <giddyup44@yahoo.com>
+
+	PR 1589/cpukit
+	* score/Makefile.am, score/include/rtems/score/thread.h,
+	score/inline/rtems/score/thread.inl: Make _Thread_Evaluate_mode() an
+	inline method. It is only used in one place and relatively simple.
+	* score/src/threadevaluatemode.c: Removed.
+
 2010-06-24	Joel Sherrill <joel.sherrilL@OARcorp.com>
 
Index: cpukit/score/Makefile.am
===================================================================
--- cpukit/score/Makefile.am	(revision 4d32a76de07c6a5ae3e9a2b2180709bfe3c9567e)
+++ cpukit/score/Makefile.am	(revision 569b3f41413f9b7b1b43cce256f4b8594dbeabdf)
@@ -142,5 +142,5 @@
 libscore_a_SOURCES += src/thread.c src/threadchangepriority.c \
     src/threadclearstate.c src/threadclose.c src/threadcreateidle.c \
-    src/threaddelayended.c src/threaddispatch.c src/threadevaluatemode.c \
+    src/threaddelayended.c src/threaddispatch.c \
     src/threadget.c src/threadhandler.c src/threadinitialize.c \
     src/threadloadenv.c src/threadready.c src/threadreset.c \
Index: cpukit/score/include/rtems/score/thread.h
===================================================================
--- cpukit/score/include/rtems/score/thread.h	(revision 4d32a76de07c6a5ae3e9a2b2180709bfe3c9567e)
+++ cpukit/score/include/rtems/score/thread.h	(revision 569b3f41413f9b7b1b43cce256f4b8594dbeabdf)
@@ -750,12 +750,4 @@
 );
 
-/**
- *  This routine evaluates the current scheduling information for the
- *  system and determines if a context switch is required.  This
- *  is usually called after changing an execution mode such as preemptability
- *  for a thread.
- */
-bool _Thread_Evaluate_mode( void );
-
 #if (CPU_PROVIDES_IDLE_THREAD_BODY == FALSE)
 /**
Index: cpukit/score/inline/rtems/score/thread.inl
===================================================================
--- cpukit/score/inline/rtems/score/thread.inl	(revision 4d32a76de07c6a5ae3e9a2b2180709bfe3c9567e)
+++ cpukit/score/inline/rtems/score/thread.inl	(revision 569b3f41413f9b7b1b43cce256f4b8594dbeabdf)
@@ -333,4 +333,25 @@
 }
 
+/**
+ *  This routine evaluates the current scheduling information for the
+ *  system and determines if a context switch is required.  This
+ *  is usually called after changing an execution mode such as preemptability
+ *  for a thread.
+ */
+RTEMS_INLINE_ROUTINE bool _Thread_Evaluate_mode( void )
+{
+  Thread_Control     *executing;
+
+  executing = _Thread_Executing;
+
+  if ( !_States_Is_ready( executing->current_state ) ||
+       ( !_Thread_Is_heir( executing ) && executing->is_preemptible ) ) {
+    _Context_Switch_necessary = true;
+    return true;
+  }
+
+  return false;
+}
+
 /**@}*/
 
Index: ukit/score/src/threadevaluatemode.c
===================================================================
--- cpukit/score/src/threadevaluatemode.c	(revision 4d32a76de07c6a5ae3e9a2b2180709bfe3c9567e)
+++ 	(revision )
@@ -1,53 +1,0 @@
-/*
- *  Thread Handler
- *
- *
- *  COPYRIGHT (c) 1989-1999.
- *  On-Line Applications Research Corporation (OAR).
- *
- *  The license and distribution terms for this file may be
- *  found in found in the file LICENSE in this distribution or at
- *  http://www.rtems.com/license/LICENSE.
- *
- *  $Id$
- */
-
-#if HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/system.h>
-#include <rtems/score/apiext.h>
-#include <rtems/score/context.h>
-#include <rtems/score/interr.h>
-#include <rtems/score/isr.h>
-#include <rtems/score/object.h>
-#include <rtems/score/priority.h>
-#include <rtems/score/states.h>
-#include <rtems/score/sysstate.h>
-#include <rtems/score/thread.h>
-#include <rtems/score/threadq.h>
-#include <rtems/score/userext.h>
-#include <rtems/score/wkspace.h>
-
-/*PAGE
- *
- *  _Thread_Evaluate_mode
- *
- *  XXX
- */
-
-bool _Thread_Evaluate_mode( void )
-{
-  Thread_Control     *executing;
-
-  executing = _Thread_Executing;
-
-  if ( !_States_Is_ready( executing->current_state ) ||
-       ( !_Thread_Is_heir( executing ) && executing->is_preemptible ) ) {
-    _Context_Switch_necessary = true;
-    return true;
-  }
-
-  return false;
-}