Index: cpukit/libmisc/monitor/mon-network.c
===================================================================
--- cpukit/libmisc/monitor/mon-network.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/monitor/mon-network.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -9,4 +9,8 @@
  *   $Id$
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <rtems.h>
Index: cpukit/libmisc/monitor/mon-part.c
===================================================================
--- cpukit/libmisc/monitor/mon-part.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/monitor/mon-part.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -4,4 +4,8 @@
  *  $Id$
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <rtems.h>
Index: cpukit/libmisc/monitor/mon-region.c
===================================================================
--- cpukit/libmisc/monitor/mon-region.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/monitor/mon-region.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -4,4 +4,8 @@
  *  $Id$
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <rtems.h>
Index: cpukit/libmisc/monitor/mon-sema.c
===================================================================
--- cpukit/libmisc/monitor/mon-sema.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/monitor/mon-sema.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -4,4 +4,8 @@
  *  $Id$
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <rtems.h>
Index: cpukit/libmisc/shell/cmp-ls.c
===================================================================
--- cpukit/libmisc/shell/cmp-ls.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/cmp-ls.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -33,4 +33,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if 0
 #include <sys/cdefs.h>
Index: cpukit/libmisc/shell/err.c
===================================================================
--- cpukit/libmisc/shell/err.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/err.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -30,4 +30,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if HAVE_NBTOOL_CONFIG_H
 #include "nbtool_config.h"
Index: cpukit/libmisc/shell/errx.c
===================================================================
--- cpukit/libmisc/shell/errx.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/errx.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -30,4 +30,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if HAVE_NBTOOL_CONFIG_H
 #include "nbtool_config.h"
Index: cpukit/libmisc/shell/filemode.c
===================================================================
--- cpukit/libmisc/shell/filemode.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/filemode.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -27,4 +27,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if defined(LIBC_SCCS) && !defined(lint)
Index: cpukit/libmisc/shell/fts.c
===================================================================
--- cpukit/libmisc/shell/fts.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/fts.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -30,4 +30,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if HAVE_NBTOOL_CONFIG_H
 #include "nbtool_config.h"
Index: cpukit/libmisc/shell/main_cp.c
===================================================================
--- cpukit/libmisc/shell/main_cp.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/main_cp.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -33,4 +33,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if 0
 #ifndef lint
Index: cpukit/libmisc/shell/main_ls.c
===================================================================
--- cpukit/libmisc/shell/main_ls.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/main_ls.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -33,4 +33,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if 0
 #include <sys/cdefs.h>
Index: cpukit/libmisc/shell/main_mv.c
===================================================================
--- cpukit/libmisc/shell/main_mv.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/main_mv.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -33,4 +33,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if 0
 #include <sys/cdefs.h>
Index: cpukit/libmisc/shell/main_rm.c
===================================================================
--- cpukit/libmisc/shell/main_rm.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/main_rm.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -27,4 +27,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if 0
Index: cpukit/libmisc/shell/print-ls.c
===================================================================
--- cpukit/libmisc/shell/print-ls.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/print-ls.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -33,4 +33,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if 0
 #include <sys/cdefs.h>
Index: cpukit/libmisc/shell/pwcache.c
===================================================================
--- cpukit/libmisc/shell/pwcache.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/pwcache.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -27,4 +27,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if defined(LIBC_SCCS) && !defined(lint)
Index: cpukit/libmisc/shell/shellconfig.c
===================================================================
--- cpukit/libmisc/shell/shellconfig.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/shellconfig.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -12,4 +12,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #define CONFIGURE_SHELL_COMMANDS_INIT
 #define CONFIGURE_SHELL_COMMANDS_ALL
Index: cpukit/libmisc/shell/utils-cp.c
===================================================================
--- cpukit/libmisc/shell/utils-cp.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/utils-cp.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -29,4 +29,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <sys/cdefs.h>
Index: cpukit/libmisc/shell/utils-ls.c
===================================================================
--- cpukit/libmisc/shell/utils-ls.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/utils-ls.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -32,4 +32,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if 0
Index: cpukit/libmisc/shell/verr.c
===================================================================
--- cpukit/libmisc/shell/verr.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/verr.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -29,4 +29,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if HAVE_NBTOOL_CONFIG_H
Index: cpukit/libmisc/shell/verrx.c
===================================================================
--- cpukit/libmisc/shell/verrx.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/verrx.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -29,4 +29,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if HAVE_NBTOOL_CONFIG_H
Index: cpukit/libmisc/shell/vis.c
===================================================================
--- cpukit/libmisc/shell/vis.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/vis.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -62,4 +62,8 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #define _DIAGASSERT(a)
Index: cpukit/libmisc/shell/vwarn.c
===================================================================
--- cpukit/libmisc/shell/vwarn.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/vwarn.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -29,4 +29,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if HAVE_NBTOOL_CONFIG_H
Index: cpukit/libmisc/shell/vwarnx.c
===================================================================
--- cpukit/libmisc/shell/vwarnx.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/vwarnx.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -29,4 +29,8 @@
  * SUCH DAMAGE.
  */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #if HAVE_NBTOOL_CONFIG_H
Index: cpukit/libmisc/shell/warn.c
===================================================================
--- cpukit/libmisc/shell/warn.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/warn.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -30,4 +30,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if HAVE_NBTOOL_CONFIG_H
 #include "nbtool_config.h"
Index: cpukit/libmisc/shell/warnx.c
===================================================================
--- cpukit/libmisc/shell/warnx.c	(revision 84b36f433a5efe864ee15d7bdfd76d0e03e83180)
+++ cpukit/libmisc/shell/warnx.c	(revision 575babcf497c56bb61c8e45d1d6715219ce4510a)
@@ -30,4 +30,8 @@
  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
 #if HAVE_NBTOOL_CONFIG_H
 #include "nbtool_config.h"