Index: c/src/lib/libbsp/sh/shsim/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/shsim/ChangeLog	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/ChangeLog	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -1,2 +1,12 @@
+2002-08-11	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* clock/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* console/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* gdbsci/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* scitab/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* start/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* startup/Makefile.am: Use .$(OBJEXT) instead of .o.
+ 	* trap34/Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-25	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/lib/libbsp/sh/shsim/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/clock/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/clock/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -7,5 +7,5 @@
 
 C_FILES = clockdrv.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/console/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/console/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -9,5 +9,5 @@
 
 C_FILES = console.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/gdbsci/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/gdbsci/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/gdbsci/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -7,5 +7,5 @@
 
 C_FILES = gdbsci.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/scitab/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/scitab/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/scitab/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -7,5 +7,5 @@
 
 C_FILES = scitab.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/start/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/start/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -4,5 +4,5 @@
 
 S_FILES = start.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(S_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/startup/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/startup/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -10,5 +10,5 @@
 C_FILES = bsplibc.c bsppost.c bspstart.c bspclean.c sbrk.c bootcard.c main.c \
     gnatinstallhandler.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES)
Index: c/src/lib/libbsp/sh/shsim/trap34/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/trap34/Makefile.am	(revision c14ba2d86889d0d5f0663f515d673007d50f1ea2)
+++ c/src/lib/libbsp/sh/shsim/trap34/Makefile.am	(revision 595fee01bed362386b33026cb6c637b4cac3e953)
@@ -9,8 +9,8 @@
 
 C_FILES = console-io.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = console-support.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 OBJS = $(C_O_FILES) $(S_O_FILES)