Index: c/src/ada-tests/mptests/mp02/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp02/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp02/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp02/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp02/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp02/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp02/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp02/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp02/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp03/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp03/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp03/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp03/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp03/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp03/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp03/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp03/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp03/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp04/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp04/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp04/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp04/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp04/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp04/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp04/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp04/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp04/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp05/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp05/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp05/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp05/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp05/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp05/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp05/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp05/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp05/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp06/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp06/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp06/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp06/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp06/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp06/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp06/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp06/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp06/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp07/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp07/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp07/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp07/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp07/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp07/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp07/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp07/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp07/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp08/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp08/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp08/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp08/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp08/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp08/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp08/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp08/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp08/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp09/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp09/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp09/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp09/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp09/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp09/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp09/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp09/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp09/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp10/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp10/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp10/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp10/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp10/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp10/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp10/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp10/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp10/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp11/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp11/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp11/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp11/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp11/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp11/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp11/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp11/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp11/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp12/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp12/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp12/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp12/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp12/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp12/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp12/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp12/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp12/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp13/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp13/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp13/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp13/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp13/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp13/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp13/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp13/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp13/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp14/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp14/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp14/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,6 @@
+## $Id$
+
+SUBDIRS = node1 node2
+
+include $(top_srcdir)/../../../testsuites/automake/subdirs.am
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp14/node1/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp14/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp14/node1/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node1$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node1
+endif
+
+node1_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am
Index: c/src/ada-tests/mptests/mp14/node2/Makefile.am
===================================================================
--- c/src/ada-tests/mptests/mp14/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
+++ c/src/ada-tests/mptests/mp14/node2/Makefile.am	(revision 603b359810d4d47dfba6e64c600d8c26ef751abe)
@@ -0,0 +1,19 @@
+## $Id$
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../testsuites/automake/compile.am
+
+include $(top_srcdir)/ada.am
+
+AM_ADAFLAGS += -I$(srcdir)/..
+
+node2$(EXEEXT): ../mptest.adb
+	$(GNATCOMPILE) -margs -a $< -o $@
+
+if EXPADA
+noinst_PROGRAMS = node2
+endif
+
+node2_SOURCES = mptest-per_node_configuration.adb
+
+include $(top_srcdir)/../../../testsuites/automake/local.am